## libreoffice 4.0.3

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python
SVNROOT      = http://svn.python.org/projects
SPHINXOPTS   =
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/sphinxext/patchlevel.py)

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees -D latex_paper_size=$(PAPER) \
                $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)

.PHONY: help checkout update build html htmlhelp latex text changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  update     to update build tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

# Note: if you update versions here, do the same in make.bat and README.txt
checkout:
	@if [ ! -d tools/sphinx ]; then \
	  echo "Checking out Sphinx..."; \
	  svn checkout $(SVNROOT)/external/Sphinx-1.0.7/sphinx tools/sphinx; \
	fi
	@if [ ! -d tools/docutils ]; then \
	  echo "Checking out Docutils..."; \
	  svn checkout $(SVNROOT)/external/docutils-0.6/docutils tools/docutils; \
	fi
	@if [ ! -d tools/jinja2 ]; then \
	  echo "Checking out Jinja..."; \
	  svn checkout $(SVNROOT)/external/Jinja-2.3.1/jinja2 tools/jinja2; \
	fi
	@if [ ! -d tools/pygments ]; then \
	  echo "Checking out Pygments..."; \
	  svn checkout $(SVNROOT)/external/Pygments-1.3.1/pygments tools/pygments; \
	fi

update: clean checkout

build: checkout
	mkdir -p build/$(BUILDER) build/doctrees
	$(PYTHON) tools/sphinx-build.py $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck: build
	@echo "Link check complete; look for any errors in the above output" \
	      "or in build/$(BUILDER)/output.txt"

suspicious: BUILDER = suspicious
suspicious: build
	@echo "Suspicious check complete; look for any errors in the above output" \
	      "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	      "positives, append that file to tools/sphinxext/susp-ignored.csv."

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest: build
	@echo "Testing of doctests in the sources finished, look at the" \
	      "results in build/doctest/output.txt"

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now copy build/pydoc-topics/topics.py" \
	      "to ../Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean:
	-rm -rf build/*
	-rm -rf tools/sphinx
	-rm -rf tools/pygments
	-rm -rf tools/jinja2
	-rm -rf tools/docutils

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# archive the epub build
	rm -rf build/epub
	make epub
	mkdir -p dist/python-$(DISTVERSION)-docs-epub
	cp -pPR build/epub/*.epub dist/python-$(DISTVERSION)-docs-epub/
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-epub.tar python-$(DISTVERSION)-docs-epub
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-epub.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-epub.zip python-$(DISTVERSION)-docs-epub)
	rm -r dist/python-$(DISTVERSION)-docs-epub
	rm dist/python-$(DISTVERSION)-docs-epub.tar

check:
	$(PYTHON) tools/rstlint.py -i tools

serve:
	../Tools/scripts/serve.py build/html

# Targets for daily automated doc build

# for development releases: always build
autobuild-dev:
	make update
	make dist SPHINXOPTS='-A daily=1'

# for stable releases: only build if not in pre-release stage (alpha, beta, rc)
autobuild-stable:
	@case $(DISTVERSION) in *[abc]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

=== android/experimental/LibreOffice4Android/Makefile ===
include ../../../config_host.mk

LIBS = \
  -Wl,--start-group \
  $(wildcard $(OUTDIR)/lib/lib*.a) \
  -Wl,--end-group

WHOLELIBS = \
  -Wl,--whole-archive \
  $(addprefix -l,$(strip \
	juh \
  )) \
  -Wl,--no-whole-archive

# The default target just builds.

all: build-ant

BOOTSTRAPDIR=../../Bootstrap
include $(BOOTSTRAPDIR)/Makefile.shared

# The package of this app
APP_PACKAGE=org.libreoffice

link-so:
# Build the single .so for this app
	mkdir -p $(OBJLOCAL)
	$(CXX) -Wl,-Map,liblo-native-code.map -Wl,--gc-sections -Wl,--version-script=../../Bootstrap/version.map -Wl,--no-keep-files-mapped -Wl,--no-undefined -DANDROID -DDISABLE_DYNLOADING -shared -o $(OBJLOCAL)/liblo-native-code.so -I$(OUTDIR)/inc native-code.cxx -L$(OUTDIR)/lib $(WHOLELIBS) $(LIBS) -lgnustl_static -landroid -llog -lz
	mkdir -p $(SODEST)
	$(STRIP) -o $(SODEST)/liblo-native-code.so $(OBJLOCAL)/liblo-native-code.so

copy-stuff:
# Then "assets". Let the directory structure under assets mimic
# that under solver for now.
#
# Please note that I have no idea what all of this is really necessary and for
# much of this stuff being copied, no idea whether it makes any sense at all.
# Much of this is copy-pasted from android/qa/sc/Makefile (where a couple of
# unit tests for sc are built, and those do seem to mostly work) and
# android/qa/desktop/Makefile (mmeeks's desktop demo, also works to some
# extent).
#
	mkdir -p assets/gz.unpack/program/ure assets/lib assets/program assets/xml/ure assets/ComponentTarget/i18npool/util
	gzip -9 <$(OUTDIR)/bin/offapi.rdb >assets/gz.unpack/program/offapi.rdb
	gzip -9 <$(OUTDIR)/bin/oovbaapi.rdb >assets/gz.unpack/program/oovbaapi.rdb
	gzip -9 <$(OUTDIR)/bin/types.rdb >assets/gz.unpack/program/types.rdb
	gzip -9 <$(OUTDIR)/bin/ure/types.rdb >assets/gz.unpack/program/ure/types.rdb
# For some reason the vnd.sun.star.expand:$LO_LIB_DIR doesn't seem to work, it expands to empty!?
	for F in xml/services xml/ure/services; do \
		sed -e 's!uri="vnd.sun.star.expand:$$LO_LIB_DIR/!uri="file://$$APP_DATA_DIR/lib/!g' <$(OUTDIR)/$$F.rdb >assets/$$F.rdb; \
	done
	cp $(SRC_ROOT)/odk/examples/java/DocumentHandling/test/test1.odt \
	   $(SRC_ROOT)/sc/qa/unit/data/xls/border.xls \
	   $(SRC_ROOT)/sw/qa/core/data/odt/test.odt \
	   $(SRC_ROOT)/sw/qa/core/data/doc/testVba.doc \
		assets
	cp $(WORKDIR)/ComponentTarget/i18npool/util/i18npool.component assets/ComponentTarget/i18npool/util
#
	mkdir -p assets/ure/share/misc assets/share/registry/res assets/share/config/soffice.cfg
	cp -R $(OUTDIR)/xml/*.xcd assets/share/registry
	mv assets/share/registry/fcfg_langpack_en-US.xcd assets/share/registry/res
	cp -R $(OUTDIR)/xml/uiconfig/* assets/share/config/soffice.cfg
	cp -R $(OUTDIR)/xml/registry/* assets/share/registry
#
# Set up rc, the "inifile". See BootstrapMap::getBaseIni(). As this app
# doesn't use soffice_main() (at least I think it shouldn't), the
# rtl::Bootstrap::setIniFilename() call there that hardcodes
# /assets/program/lofficerc isn't executed. Instead the hardcoding of
# /assets/rc in BootstrapMap::getBaseIni() gets used.
	echo '[Bootstrap]' > assets/rc
	echo 'Logo=1' >> assets/rc
	echo 'NativeProgress=1' >> assets/rc
	echo 'URE_BOOTSTRAP=file:///assets/program/fundamentalrc' >> assets/rc
#	echo 'RTL_LOGFILE=file:///dev/log/main' >> assets/rc
	echo 'HOME=$$APP_DATA_DIR/cache' >> assets/rc
	echo 'OSL_SOCKET_PATH=$$APP_DATA_DIR/cache' >> assets/rc
#
# Set up fundamentalrc
	echo '[Bootstrap]' > assets/program/fundamentalrc
	echo 'LO_LIB_DIR=file://$$APP_DATA_DIR/lib/' >> assets/program/fundamentalrc
	echo 'URE_LIB_DIR=file://$$APP_DATA_DIR/lib/' >> assets/program/fundamentalrc # checkme - is this used to find configs ?
	echo 'BRAND_BASE_DIR=file:///assets' >> assets/program/fundamentalrc
	echo 'CONFIGURATION_LAYERS=xcsxcu:$${BRAND_BASE_DIR}/share/registry module:$${BRAND_BASE_DIR}/share/registry/modules res:$${BRAND_BASE_DIR}/share/registry' >> assets/program/fundamentalrc
	echo 'URE_BIN_DIR=file:///assets/ure/bin/dir/nothing-here/we-can/exec-anyway' >> assets/program/fundamentalrc
#
# Set up unorc
	echo '[Bootstrap]' > assets/program/unorc
	echo 'URE_INTERNAL_LIB_DIR=file://$$APP_DATA_DIR/lib/' >> assets/program/unorc
	echo 'UNO_TYPES=$$APP_DATA_DIR/program/ure/types.rdb $$APP_DATA_DIR/program/types.rdb $$APP_DATA_DIR/program/offapi.rdb $$APP_DATA_DIR/program/oovbaapi.rdb' >> assets/program/unorc
	echo 'UNO_SERVICES=file:///assets/xml/ure/services.rdb file:///assets/xml/services.rdb <$$BRAND_BASE_DIR/program/services>*' >> assets/program/unorc
#
# Set up bootstraprc
	echo '[Bootstrap]' > assets/program/bootstraprc
	echo 'InstallMode=<installmode>' >> assets/program/bootstraprc
	echo 'ProductKey=LibreOffice 3.6' >> assets/program/bootstraprc
	echo 'UserInstallation=file://$$APP_DATA_DIR' >> assets/program/bootstraprc
#
# Set up versionrc
	echo '[Version]' > assets/program/versionrc
	echo 'AllLanguages=en-US' >> assets/program/versionrc
	echo 'BuildVersion=' >> assets/program/versionrc
	echo 'buildid=dead-beef' >> assets/program/versionrc
	echo 'ProductBuildid=3' >> assets/program/versionrc
	echo 'ProductMajor=360' >> assets/program/versionrc
	echo 'ProductMinor=1' >> assets/program/versionrc
	echo 'ProductSource=OOO350' >> assets/program/versionrc
	echo 'ReferenceOOoMajorMinor=3.6' >> assets/program/versionrc
#
# .res files
	mkdir -p assets/program/resource
	cp $(OUTDIR)/bin/*en-US.res assets/program/resource
#
# Assets that are unpacked at run-time into the app's data directory. These
# are files read by non-LO code, fontconfig and freetype for now, that doesn't
# understand "/assets" paths.
	mkdir -p assets/unpack/etc/fonts
	cp fonts.conf assets/unpack/etc/fonts
# $UserInstallation/user/fonts is added to the fontconfig path in
# vcl/generic/fontmanager/helper.cxx: psp::getFontPath(). UserInstallation is
# set to the app's data dir above.
	mkdir -p assets/gz.unpack/user/fonts
	for F in $(OUTDIR)/pck/Liberation*.ttf $(OUTDIR)/pck/Gen*.ttf $(OUTDIR)/pck/opens___.ttf; do \
		gzip -9 <$$F >assets/gz.unpack/user/fonts/`basename $$F`; \
	done
#
# Then gdbserver and gdb.setup so that we can debug with ndk-gdb.
#
	mkdir -p $(SODEST)
	cp $(ANDROID_NDK_GDBSERVER) $(SODEST)
	echo set solib-search-path ./obj/local/$(ANDROID_APP_ABI) >$(SODEST)/gdb.setup

build-ant: android_version_setup copy-stuff link-so properties
	echo sdk.dir=$(ANDROID_SDK_HOME) >../../abs-lib/local.properties
# ActionBarSherlock uses the v4 support library, apparently one needs to copy
# it like this for it to be found
	mkdir -p ../../abs-lib/libs
	cp $(ANDROID_SDK_HOME)/extras/android/support/v4/android-support-v4.jar ../../abs-lib/libs
#
# Copy jar files we need
#
	for F in $(strip \
		   java_uno \
		   juh \
		   jurt \
		   ridl \
		   unoil \
		   unoloader \
		  ); do \
	    $(call COPYJAR,$(OUTDIR)/bin/$${F}.jar); \
	done
#
	unset JAVA_HOME && $(ANT) debug

run:
	adb shell am start -n $(APP_PACKAGE)/.ui.LibreOfficeUIActivity -e input /assets/test1.odt

=== android/qa/desktop/Makefile ===
# lo-main-library - parameter denoting which shlib to load and execute
# 'lo_main' from

include ../../../config_host.mk

BOOTSTRAPDIR=../../Bootstrap
include $(BOOTSTRAPDIR)/Makefile.shared

# The package of this app
APP_PACKAGE=org.libreoffice.android.libo

# The name of the Bootstrap activity class
BOOTSTRAP=org.libreoffice.android.Bootstrap

# The default target just builds.

all: build-ant

buildrcs:
# main sofficerc ini ...
	mkdir -p assets/program/
	echo "[Bootstrap]" > assets/program/lofficerc
	echo "Logo=1" >> assets/program/lofficerc
	echo "NativeProgress=1" >> assets/program/lofficerc
	echo "URE_BOOTSTRAP=file:///assets/program/fundamentalrc" >> assets/program/lofficerc
#	echo "RTL_LOGFILE=file:///dev/log/main" >> assets/program/lofficerc
	echo "HOME=$(APP_DATA_PATH)/files" >> assets/program/lofficerc
	echo "OSL_SOCKET_PATH=$(APP_DATA_PATH)/files" >> assets/program/lofficerc
# - this looks useful but breaks more than it fixes ...
#	echo "DISABLE_EXTENSION_SYNCHRONIZATION=1" >> assets/program/lofficerc

# fundamentalrc ini ...
	echo "[Bootstrap]" > assets/program/fundamentalrc
	echo "LO_LIB_DIR=file://$(APP_DATA_PATH)/lib/" >> assets/program/fundamentalrc
	echo "URE_LIB_DIR=file://$(APP_DATA_PATH)/lib/" >> assets/program/fundamentalrc # checkme - is this used to find configs ?
	echo "BRAND_BASE_DIR=file:///assets" >> assets/program/fundamentalrc
	echo 'CONFIGURATION_LAYERS=xcsxcu:$${BRAND_BASE_DIR}/share/registry module:$${BRAND_BASE_DIR}/share/registry/modules res:$${BRAND_BASE_DIR}/share/registry' >> assets/program/fundamentalrc
	echo 'URE_BIN_DIR=file:///assets/ure/bin/dir/not-here/can-we/exec-anyway' >> assets/program/fundamentalrc
	echo 'URE_MORE_TYPES=file:///assets/ure/share/misc/types.rdb file:///assets/program/types/types.rdb' >> assets/program/fundamentalrc
	echo 'URE_MORE_SERVICES= <$$BRAND_BASE_DIR/program/services>*' >> assets/program/fundamentalrc
	echo 'BUNDLED_EXTENSIONS=$$BRAND_BASE_DIR/share/extensions' >> assets/program/fundamentalrc
	echo 'BUNDLED_EXTENSIONS_USER=$${$$BRAND_BASE_DIR/program/bootstraprc:UserInstallation}/user/extensions/bundled' >> assets/program/fundamentalrc
	echo 'TMP_EXTENSIONS=$${$$BRAND_BASE_DIR/program/bootstraprc:UserInstallation}/user/extensions/tmp' >> assets/program/fundamentalrc
	echo 'SHARED_EXTENSIONS_USER=$${$$BRAND_BASE_DIR/program/bootstraprc:UserInstallation}/user/extensions/shared' >> assets/program/fundamentalrc
	echo 'UNO_SHARED_PACKAGES=$$BRAND_BASE_DIR/share/uno_packages' >> assets/program/fundamentalrc
	echo 'UNO_SHARED_PACKAGES_CACHE=$$UNO_SHARED_PACKAGES/cache' >> assets/program/fundamentalrc
	echo 'UNO_USER_PACKAGES=$${$$BRAND_BASE_DIR/program/bootstraprc:UserInstallation}/user/uno_packages' >> assets/program/fundamentalrc
	echo 'UNO_USER_PACKAGES_CACHE=$$UNO_USER_PACKAGES/cache' >> assets/program/fundamentalrc
	echo 'PKG_BundledUnoFile=$$BUNDLED_EXTENSIONS_USER/registry/com.sun.star.comp.deployment.component.PackageRegistryBackend/unorc' >> assets/program/fundamentalrc
	echo 'PKG_SharedUnoFile=$$SHARED_EXTENSIONS_USER/registry/com.sun.star.comp.deployment.component.PackageRegistryBackend/unorc' >> assets/program/fundamentalrc
	echo 'PKG_UserUnoFile=$$UNO_USER_PACKAGES_CACHE/registry/com.sun.star.comp.deployment.component.PackageRegistryBackend/unorc' >> assets/program/fundamentalrc

# unorc ini ...
	echo "[Bootstrap]" > assets/program/unorc
	echo "URE_INTERNAL_LIB_DIR=file://$(APP_DATA_PATH)/lib/" >> assets/program/unorc
	echo 'UNO_TYPES=file:///assets/ure/share/misc/types.rdb file:///assets/program/types/types.rdb $${URE_MORE_TYPES}' >> assets/program/unorc
	echo 'UNO_SERVICES=file:///assets/ure/share/misc/services.rdb $${URE_MORE_SERVICES}' >> assets/program/unorc
# bootstraprc ini ...
	echo "[Bootstrap]" > assets/program/bootstraprc
	echo "InstallMode=<installmode>" >> assets/program/bootstraprc
	echo "ProductKey=LibreOffice 3.5" >> assets/program/bootstraprc
	echo "UserInstallation=file://$(APP_DATA_PATH)/files/.libreoffice" >> assets/program/bootstraprc

# versionrc ini ...
	echo "[Version]" > assets/program/versionrc
	echo "AllLanguages=en-US" >> assets/program/versionrc
	echo "BuildVersion=" >> assets/program/versionrc
	echo "buildid=dead-beef" >> assets/program/versionrc
	echo "ExtensionUpdateURL=http://updateexte.libreoffice.org/ExtensionUpdateService/check.Update" >> assets/program/versionrc
	echo "ProductBuildid=3" >> assets/program/versionrc
	echo "ProductMajor=360" >> assets/program/versionrc
	echo "ProductMinor=1" >> assets/program/versionrc
	echo "ProductSource=OOO350" >> assets/program/versionrc
	echo "ReferenceOOoMajorMinor=3.6" >> assets/program/versionrc
	echo "UpdateID=LibreOffice_3_en-US" >> assets/program/versionrc
	echo "UpdateURL=" >> assets/program/versionrc
	echo "UpdateUserAgent=<PRODUCT> (${buildid}; ${_OS}; ${_ARCH}; BundledLanguages=${AllLanguages})" >> assets/program/versionrc
	echo "Vendor=SelfCompiledGit" >> assets/program/versionrc

copy-stuff: buildrcs
#
# Copy shared libraries we need to libs/$(ANDROID_APP_ABI) so that ant will
# include them in the .apk.
#
# Copy them to obj/local/$(ANDROID_APP_ABI), too, where gdb will look for
# them.
#
	mkdir -p $(SODEST) $(OBJLOCAL)
#
# First the most important one, liblo-bootstrap.so
	$(call COPY,$(OUTDIR)/lib/liblo-bootstrap.so)
#
# Libs and UNO components that we need.
#
	for F in $(strip \
		  analysislo \
		  basegfxlo \
		  bootstrap.uno \
		  comphelpgcc3 \
		  cppcanvaslo \
		  embobj \
		  expwrap.uno \
		  gcc3_uno \
		  i18nisolang1gcc3 \
		  icudatalo \
		  icui18nlo \
		  iculelo \
		  icuuclo \
		  jvmaccessgcc3 \
		  jvmfwk \
		  libotouchlo \
		  introspection.uno \
		  localedata_en \
		  localedata_es \
		  localedata_euro \
		  localedata_others \
		  mergedlo \
		  msfilterlo \
		  ooxlo \
		  reflection.uno \
		  reg \
		  stocservices.uno \
		  store \
		  test \
		  tllo \
		  ucbhelper4gcc3 \
		  uno_cppu \
		  uno_cppuhelpergcc3 \
		  uno_sal \
		  uno_salhelpergcc3 \
		  unordflo \
		  unotest \
		  unoxmllo \
		  vbahelperlo \
		  xml2 \
		  xmlreader \
		  xmlsecurity \
		  xslt \
		  \
		  swlo \
		  swuilo \
		  swdlo \
		  \
		  sclo \
		  scdlo \
		  scnlo \
		  scuilo \
		  scfiltlo \
		  \
		  chartcontrollerlo \
		  chartcorelo \
		  ); do \
	    $(call COPYSO,$(OUTDIR)/lib/lib$${F}.so); \
	done

#
# Then the shared GNU C++ library
	$(call COPYSO,$(ANDROID_NDK_HOME)/sources/cxx-stl/gnu-libstdc++/$(ANDROID_NDK_TOOLCHAIN_VERSION_SUBDIR)libs/$(ANDROID_APP_ABI)/libgnustl_shared.so)
#
# Then other "assets" that can be left in the .apk. Let the directory
# structure under assets mimic the install set - except for the fact
# that program/ is renamed to lib/ and we put the ure/lib .so's into
# the assets/lib directory too.
	mkdir -p assets/program/types assets/program/services
	mkdir -p assets/program/resource
	mkdir -p assets/ure/share/misc assets/share/registry/res
	mkdir -p assets/share/config/soffice.cfg
# uno types & services
	cp $(OUTDIR)/bin/types.rdb assets/program/types/
	cp $(OUTDIR)/bin/ure/types.rdb assets/ure/share/misc/
	cp $(OUTDIR)/xml/services.rdb assets/program/services
	cp $(OUTDIR)/xml/ure/services.rdb assets/ure/share/misc/
# config
	cp -R $(OUTDIR)/xml/*.xcd assets/share/registry/
	mv assets/share/registry/fcfg_langpack_en-US.xcd assets/share/registry/res/
	cp -R $(OUTDIR)/xml/uiconfig/* assets/share/config/soffice.cfg
	cp -R $(OUTDIR)/bin/images_tango.zip assets/share/config/images.zip
# .res files
	cp $(OUTDIR)/bin/*en-US.res assets/program/resource/
# presets - becomes the users home directory, .stamp forces .zip dir creation
	for D in $(strip autocorr autotext backup basic config gallery \
	         psprint/driver psprint/fontmetric template \
		 uno_packages/cache wordbook); do \
		mkdir -p assets/presets/$$D ; \
		echo "content" > assets/presets/$$D/stamp; \
	done
# shell / splash images
	cp -r $(SRC_ROOT)/icon-themes/galaxy/brand/* assets/program
# Then assets that are unpacked at run-time into the app's data directory.
	mkdir -p assets/unpack/etc/fonts
	cp fonts.conf assets/unpack/etc/fonts
# A sample file for fun ...
	mkdir -p assets/demo
	if test -f /opt/libreoffice/tmp/writer.odt; then cp /opt/libreoffice/tmp/writer.odt assets/demo; fi
#
# Then gdbserver and gdb.setup so that we can debug with ndk-gdb.
#
	cp $(ANDROID_NDK_GDBSERVER) $(SODEST)
	echo set solib-search-path ./obj/local/$(ANDROID_APP_ABI) >$(SODEST)/gdb.setup


build-ant: copy-stuff properties
	unset JAVA_HOME && $(ANT) debug

run:
	echo "-env:INIFILENAME=file:///assets/program/sofficerc" > cmdline
#	echo "file:///assets/demo/writer.odt" > cmdline
	$(ANDROID_SDK_HOME)/platform-tools/adb push cmdline $(APP_DATA_PATH)/cmdline
	$(ANDROID_SDK_HOME)/platform-tools/adb shell am start -n $(APP_PACKAGE)/$(BOOTSTRAP) -e lo-main-delay 20 -e lo-main-indirect-cmdline "$(APP_DATA_PATH)/cmdline"
# add -e lo-strace yes # if you want that

=== odk/examples/java/Inspector/Makefile ===
#*************************************************************************
#
#  The Contents of this file are made available subject to the terms of
#  the BSD license.
#
#  Copyright 2000, 2010 Oracle and/or its affiliates.
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#  1. Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#  2. Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#  3. Neither the name of Sun Microsystems, Inc. nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
#  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
#  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
#  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
#  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#  TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
#  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#**************************************************************************

# Builds the Java InstanceInspector component example of the SDK.

PRJ=../../..
SETTINGS=$(PRJ)/settings

include $(SETTINGS)/settings.mk
include $(SETTINGS)/std.mk
include $(SETTINGS)/dk.mk

# Define non-platform/compiler specific settings

# we use the sample directory name dor separating this example
# from others in the output directory
SAMPLE_NAME=InstanceInspector
SAMPLE_CLASS_OUT=$(OUT_CLASS)/$(SAMPLE_NAME)
SAMPLE_GEN_OUT=$(OUT_MISC)/$(SAMPLE_NAME)

# some special macro names for separating the component jar stuff
COMP_NAME=Inspector
COMP_CLASS_OUT=$(SAMPLE_CLASS_OUT)/$(COMP_NAME)
COMP_GEN_OUT=$(SAMPLE_GEN_OUT)/$(COMP_NAME)
COMP_RDB_NAME=$(COMP_NAME).uno.rdb
COMP_RDB=$(COMP_GEN_OUT)/$(COMP_RDB_NAME)
COMP_PACKAGE=$(OUT_BIN)/$(COMP_NAME).$(UNOOXT_EXT)
COMP_PACKAGE_URL=$(subst \\,\,"$(COMP_PACKAGE_DIR)$(PS)$(COMP_NAME).$(UNOOXT_EXT)")
COMP_JAR_NAME=$(COMP_NAME).uno.jar
COMP_JAR=$(SAMPLE_CLASS_OUT)/$(COMP_JAR_NAME)
COMP_JAR_MANIFEST=$(COMP_GEN_OUT)/$(COMP_NAME).uno.Manifest
COMP_UNOPKG_MANIFEST = $(COMP_GEN_OUT)/META-INF/manifest.xml
COMP_REGISTERFLAG=$(COMP_GEN_OUT)$(PS)java_$(COMP_NAME)_register_component.flag

IDLFILES = InstanceInspector.idl \
	XInstanceInspector.idl

# normally the idl file should be stored in a directory tree fitting the
# module structure, for the example we know the module structure
PACKAGE = org/openoffice

COMP_JAVAFILES = XDialogProvider.java XTreeControlProvider.java XTreePathProvider.java MethodParametersDialog.java HideableMutableTreeNode.java HideableTreeModel.java Introspector.java XUnoNode.java SwingUnoNode.java UnoNode.java XUnoMethodNode.java SwingUnoMethodNode.java UnoMethodNode.java XUnoPropertyNode.java SwingUnoPropertyNode.java UnoPropertyNode.java XUnoFacetteNode.java SwingUnoFacetteNode.java TDocSupplier.java UnoTreeRenderer.java InspectorAddon.java XLanguageSourceCodeGenerator.java SourceCodeGenerator.java InspectorPane.java SwingDialogProvider.java SwingTreeControlProvider.java SwingTreePathProvider.java Inspector.java 
COMP_CLASSFILES = $(patsubst %.java,$(COMP_CLASS_OUT)/%.class,$(COMP_JAVAFILES))

GEN_CLASSFILES = $(patsubst %.idl,$(SAMPLE_CLASS_OUT)/$(PACKAGE)/%.class,$(IDLFILES))
GEN_TYPELIST = $(subst /,.,$(patsubst %.idl,-T$(PACKAGE)/% ,$(IDLFILES)))
GEN_URDFILES = $(patsubst %.idl,$(SAMPLE_GEN_OUT)/%.urd,$(IDLFILES))

# the generated types are necessary for the component jar
GEN_CLASSFILENAMES = $(subst $(SAMPLE_CLASS_OUT)/,,$(GEN_CLASSFILES))

SDK_CLASSPATH = $(subst $(EMPTYSTRING) $(PATH_SEPARATOR),$(PATH_SEPARATOR),$(CLASSPATH)\
		$(PATH_SEPARATOR)$(SAMPLE_CLASS_OUT)\
		$(PATH_SEPARATOR)$(COMP_CLASS_OUT))

COMP_IMAGE_FILES= images/containers_16.png \
		images/content_16.png \
		images/interfaces_16.png \
		images/methods_16.png \
		images/properties_16.png \
		images/services_16.png

# Targets
.PHONY: ALL
ALL : JavaInspectorExample

include $(SETTINGS)/stdtarget.mk

# rule for component manifest file
$(COMP_GEN_OUT)/%.Manifest :
	-$(MKDIR) $(subst /,$(PS),$(@D))
	@echo RegistrationClassName: $(basename $(basename $(@F)))> $@

# rule for compiling the IDL files
$(SAMPLE_GEN_OUT)/%.urd : %.idl
	-$(MKDIR) $(subst /,$(PS),$(@D))
	$(IDLC) -C -I. -I$(IDL_DIR) -O$(SAMPLE_GEN_OUT) $<

# rule for creating the component rdb file
$(COMP_GEN_OUT)/%.rdb : $(GEN_URDFILES)
	-$(DEL) $(subst \\,\,$(subst /,$(PS),$@))
	-$(MKDIR) $(subst /,$(PS),$(@D))
	$(REGMERGE) $@ /UCR $(GEN_URDFILES)

# rule for creating IDL dependent class files
$(GEN_CLASSFILES) : $(COMP_RDB)
	-$(MKDIR) $(subst /,$(PS),$(@D))
	$(JAVAMAKER) -BUCR -nD $(GEN_TYPELIST) -O$(SAMPLE_CLASS_OUT) $(COMP_RDB) -X$(URE_TYPES) -X$(OFFICE_TYPES)

# component as well as application are dependent from the generated types
# rule for component class files
$(COMP_CLASS_OUT)/%.class : %.java $(GEN_CLASSFILES)
	-$(MKDIR) $(subst /,$(PS),$(@D))
	$(SDK_JAVAC) $(JAVAC_FLAGS) -classpath "$(SDK_CLASSPATH)" -sourcepath . -d $(COMP_CLASS_OUT) $<

# rule for component jar file
$(COMP_JAR) : $(COMP_JAR_MANIFEST) $(COMP_CLASSFILES) $(COMP_IMAGE_FILES)
	-$(DEL) $(subst \\,\,$(subst /,$(PS),$@))
	-$(MKDIR) $(subst /,$(PS),$(@D))
	$(SDK_JAR) cvfm $@  $< -C $(COMP_CLASS_OUT) .
	+cd $(subst /,$(PS),$(SAMPLE_CLASS_OUT)) && $(SDK_JAR) uvf $(@F) $(GEN_CLASSFILENAMES)
	+$(SDK_JAR) uvf $@ $(COMP_IMAGE_FILES)

# rule for component package manifest
$(COMP_GEN_OUT)/%/manifest.xml :
	-$(MKDIR) $(subst /,$(PS),$(@D))
	@echo $(OSEP)?xml version="$(QM)1.0$(QM)" encoding="$(QM)UTF-8$(QM)"?$(CSEP) > $@
	@echo $(OSEP)!DOCTYPE manifest:manifest PUBLIC "$(QM)-//OpenOffice.org//DTD Manifest 1.0//EN$(QM)" "$(QM)Manifest.dtd$(QM)"$(CSEP) >> $@
	@echo $(OSEP)manifest:manifest xmlns:manifest="$(QM)http://openoffice.org/2001/manifest$(QM)"$(CSEP) >> $@
	@echo $(SQM)  $(SQM)$(OSEP)manifest:file-entry manifest:media-type="$(QM)application/vnd.sun.star.configuration-data$(QM)" >> $@
	@echo $(SQM)                       $(SQM)manifest:full-path="$(QM)Addons.xcu$(QM)"/$(CSEP) >> $@
	@echo $(SQM)  $(SQM)$(OSEP)manifest:file-entry manifest:media-type="$(QM)application/vnd.sun.star.configuration-data$(QM)" >> $@
	@echo $(SQM)                       $(SQM)manifest:full-path="$(QM)ProtocolHandler.xcu$(QM)"/$(CSEP) >> $@
	@echo $(SQM)  $(SQM)$(OSEP)manifest:file-entry manifest:media-type="$(QM)application/vnd.sun.star.configuration-schema$(QM)" >> $@
	@echo $(SQM)                       $(SQM)manifest:full-path="$(QM)ObjectInspector.xcs$(QM)"/$(CSEP) >> $@
	@echo $(SQM)  $(SQM)$(OSEP)manifest:file-entry manifest:media-type="$(QM)application/vnd.sun.star.configuration-data$(QM)" >> $@
	@echo $(SQM)                       $(SQM)manifest:full-path="$(QM)ObjectInspector.xcu$(QM)"/$(CSEP) >> $@
	@echo $(SQM)  $(SQM)$(OSEP)manifest:file-entry manifest:media-type="$(QM)application/vnd.sun.star.uno-typelibrary;type=RDB$(QM)" >> $@
	@echo $(SQM)                       $(SQM)manifest:full-path="$(QM)$(subst /META-INF,,$(subst $(SAMPLE_GEN_OUT)/,,$(@D))).uno.rdb$(QM)"/$(CSEP) >> $@
	@echo $(SQM)  $(SQM)$(OSEP)manifest:file-entry manifest:media-type="$(QM)application/vnd.sun.star.uno-component;type=Java$(QM)" >> $@
	@echo $(SQM)                       $(SQM)manifest:full-path="$(QM)$(subst /META-INF,,$(subst $(SAMPLE_GEN_OUT)/,,$(@D))).uno.jar$(QM)"/$(CSEP) >> $@
	@echo $(OSEP)/manifest:manifest$(CSEP) >> $@

# rule for component package file
$(COMP_PACKAGE) : $(COMP_RDB) $(COMP_JAR) Addons.xcu ProtocolHandler.xcu  ObjectInspector.xcu ObjectInspector.xcs $(COMP_UNOPKG_MANIFEST)
	-$(DEL) $(subst \\,\,$(subst /,$(PS),$@))
	-$(MKDIR) $(subst /,$(PS),$(@D))
	cd $(subst /,$(PS),$(COMP_GEN_OUT)) && $(SDK_ZIP) ../../../bin/$(@F) $(COMP_RDB_NAME)

	cd $(subst /,$(PS),$(SAMPLE_CLASS_OUT)) && $(SDK_ZIP) -u ../../bin/$(@F) $(COMP_JAR_NAME)
	$(SDK_ZIP) -u $@ Addons.xcu ProtocolHandler.xcu ObjectInspector.xcu ObjectInspector.xcs
	cd $(subst /,$(PS),$(COMP_GEN_OUT)) && $(SDK_ZIP) -u ../../../bin/$(@F) META-INF/manifest.xml

$(COMP_REGISTERFLAG) : $(COMP_PACKAGE)
ifeq "$(SDK_AUTO_DEPLOYMENT)" "YES"
	-$(DEL) $(subst \\,\,$(subst /,$(PS),$@))
	-$(MKDIR) $(subst /,$(PS),$(@D))
	$(DEPLOYTOOL) $(COMP_PACKAGE_URL)
	@echo flagged > $(subst /,$(PS),$@)
else
	@echo --------------------------------------------------------------------------------
	@echo  If you want to install your component automatically, please set the environment
	@echo  variable SDK_AUTO_DEPLOYMENT = YES. But note that auto deployment is only
	@echo  possible if no office instance is running.
	@echo --------------------------------------------------------------------------------
endif

JavaInspectorExample : $(COMP_REGISTERFLAG)
	@echo --------------------------------------------------------------------------------
	@echo The InstanceInspector component was installed if SDK_AUTO_DEPLOYMENT = YES.
	@echo You can use this component inside your office installation, see the example
	@echo document.
	@echo -
	@echo $(MAKE) InstanceInspectorTest.odt.load
	@echo --------------------------------------------------------------------------------

InstanceInspectorTest.odt.load : $(COMP_REGISTERFLAG)
	"$(OFFICE_PROGRAM_PATH)$(PS)soffice" $(basename $@)

.PHONY: clean
clean :
	-$(DELRECURSIVE) $(subst /,$(PS),$(SAMPLE_CLASS_OUT))
	-$(DELRECURSIVE) $(subst /,$(PS),$(SAMPLE_GEN_OUT))
	-$(DEL) $(subst \\,\,$(subst /,$(PS),$(COMP_PACKAGE_URL)))

=== debian/changelog ===
libreoffice (1:4.0.3-2~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.

 -- Rene Engelhard <rene@debian.org>  Sat, 11 May 2013 11:11:45 +0000

libreoffice (1:4.0.3-2) unstable; urgency=low

  * debian/control.in:
    - add Breaks: libjaxe-java (<= 3.5-2) for saxon9.jar disappearing from
      -java-common
    - remove -core Depends: for -style and add Enhances: libreoffice-core 
      for them. Apps should depend on their data files but data files not on
      the apps
  * debian/rules:
    - build with libboost1.53-dev to work around mdds-using sc unit tests
      failing to build with sids new gcc-4.7
    - move libxmlreader.so (although not versioned...) and libreg.so.3 (although
      private...) and it's dependency libstore.so.3 into uno-libs3 as
      libuno_cppuhelpergcc3.so.3 now links to it (breaks ure->uno-libs3->ure
      dependency loop)

   (hopefully breaking those two dependency loops closes: #705158, thanks
    David Kalnischkies - see also #707578)

 -- Rene Engelhard <rene@debian.org>  Sat, 11 May 2013 01:20:03 +0200

libreoffice (1:4.0.3-1) unstable; urgency=low

  * LibreOffice 4.0.3 final (identical to rc3)

  * upload to unstable

 -- Rene Engelhard <rene@debian.org>  Sun, 05 May 2013 17:55:51 +0200

libreoffice (1:4.0.3~rc3-1) experimental; urgency=low

  * new upstream release candidate

  * debian/control.in:
    - break zotero-libreoffice-integration (<= 3.0.11.1-26-g08fb709-1), see
      #705998)
    - add (commented out for now - as long we are python3.3-uno anyways) the
      missing Provides: ${python3:Provides}
  * debian/uno-libs3.symbols: update and cleanup - use (symver) instead
    of *@...
  * debian/copyright: mention gbuild (and its makefiles) are MPL-2.0

 -- Rene Engelhard <rene@debian.org>  Thu, 02 May 2013 21:06:26 +0200

libreoffice (1:4.0.3~rc1-3) experimental; urgency=low

  * The "the third time is a charm" release
  * fix check rule again: move - where it actually works; also ignore
    test failures on s390 and powerpc and simplify logic

 -- Rene Engelhard <rene@debian.org>  Sun, 21 Apr 2013 17:14:49 +0200

libreoffice (1:4.0.3~rc1-2) experimental; urgency=low

  * brown paper bag release
  * fix make -k check || make check rule

 -- Rene Engelhard <rene@debian.org>  Fri, 19 Apr 2013 17:47:59 +0200

libreoffice (1:4.0.3~rc1-1) experimental; urgency=low

  * new upstream release candidate

  * debian/control.librelogo.in:
    - actually use ${pyuno-depends}... 
  * debian/rules:
    - enable liblangtag on arm*, too now that it's available there
    - Use internal clucene until clucene 2.x is in unstable. Remove
      arm* hack for internal clucene as it seems to work in the
      meanwhile
    - explicitly set JDK=openjdk again until default-jdk (>= 1:1.7-48)
      is in unstable (needed for ia64 defaulting to java7)
    - run make -k check || make check (try to work around spurious failures) and
      ignore test suite failures (on the second run) on armhf, ia64, sparc,
      mips(el)

 -- Rene Engelhard <rene@debian.org>  Wed, 10 Apr 2013 23:15:27 +0200

libreoffice (1:4.0.2~rc2-2) experimental; urgency=low

  * debian/patches/boost-1.53.diff: backport buildfixes for boost 1.53
    from master

  * debian/rules:
    - build-depend on libboost-dev 1.53 when building with gcc 4.8,
      see 701310/695826 (closes: #701310)
    - always build -dbg package if we build -subsequentcheckbase, as the
      test depends on -dbg
    - build against "new" libhsqldb1.8.0-java
    - we need to build-depend on python3 even when building python3.3-uno
      as it contains dh_python3...
  * debian/control.in:
    - add Breaks: on libreoffice-writer2latex/libreoffice-writer2xhtml
      (<< 1.0.2-9) due to LO 4.0 API change

 -- Rene Engelhard <rene@debian.org>  Tue, 02 Apr 2013 00:13:23 +0200

=== debian/control ===
Source: libreoffice
Section: editors
Priority: optional
Maintainer: Debian LibreOffice Maintainers <debian-openoffice@lists.debian.org>
Uploaders: Rene Engelhard <rene@debian.org>
Build-Depends: ant (>= 1.7.0),
               ant-optional (>= 1.7.0),
               autoconf,
               automake,
               bc,
               bison,
               bzip2,
               cpp-4.7,
               debhelper (>= 7.2.3~),
               dmake (>= 1:4.11),
               dpkg-dev (>= 1.16.1),
               fastjar,
               flex | flex-old,
               g++-mingw-w64-i686 [i386 amd64],
               gcj-jdk [hppa kfreebsd-i386 kfreebsd-amd64],
               gcj-native-helper [hppa kfreebsd-amd64 kfreebsd-i386],
               gdb,
               gettext,
               gperf,
               javahelper (>= 0.37~),
               junit4 (>= 4.8.2-2),
               kdelibs5-dev (>= 4:4.3.4),
               libarchive-zip-perl,
               libbluetooth-dev [!kfreebsd-amd64 !kfreebsd-i386],
               libboost-date-time-dev (>= 1.38),
               libboost-dev (>= 1.38),
               libc0.1 (>= 2.10.2-7) [kfreebsd-i386 kfreebsd-amd64],
               libcairo2-dev,
               libcppunit-dev (>= 1.12),
               libcups2-dev,
               libdbus-glib-1-dev (>= 0.70),
               libebook1.2-dev,
               libexpat1-dev,
               libexttextcat-dev (>= 3.1.1),
               libfontconfig1-dev,
               libfreetype6-dev,
               libgcj-common (>= 1:4.4.1) [hppa kfreebsd-amd64 kfreebsd-i386],
               libgconf2-dev,
               libgl1-mesa-dev [!armel !mips !mipsel],
               libglib2.0-dev (>= 2.15.0),
               libglu1-mesa-dev [!armel !mips !mipsel],
               libgraphite2-dev (>= 0.9.3) [!armel !sparc],
               libgstreamer-plugins-base0.10-dev,
               libgtk-3-dev (>= 3.2~),
               libgtk2.0-dev (>= 2.10),
               libhsqldb-java (>> 1.8.0.10),
               libhunspell-dev (>= 1.1.5-2),
               libhyphen-dev (>= 2.4),
               libice-dev,
               libicu-dev (>= 4.6),
               libjpeg-dev,
               liblcms2-dev,
               libldap2-dev,
               liblpsolve55-dev (>= 5.5.0.13-5+b1),
               libmysqlclient-dev,
               libmysqlcppconn-dev (>= 1.1.0~r791),
               libmythes-dev (>= 2:1.2),
               libneon27-gnutls-dev,
               libnss3-dev (>= 3.12.3),
               liborbit2-dev,
               libpng12-dev,
               libpoppler-cpp-dev,
               libpoppler-dev (>= 0.8.0),
               libpoppler-private-dev,
               libpq-dev (>= 9.0~),
               libqt4-dev (>= 4:4.8),
               librdf0-dev (>= 1.0.8),
               libsane-dev,
               libsm-dev,
               libssl-dev,
               libsuitesparse-dev (>= 1:3.4.0),
               libvigraimpex-dev,
               libvisio-dev,
               libwpd-dev (>= 0.9.0),
               libwpg-dev (>= 0.2.0),
               libwps-dev (>= 0.2.0),
               libx11-dev,
               libxaw7-dev,
               libxext-dev,
               libxinerama-dev,
               libxkbfile-dev,
               libxml-parser-perl,
               libxml2-dev,
               libxml2-utils,
               libxrandr-dev,
               libxrender-dev,
               libxslt1-dev,
               libxt-dev,
               libxtst-dev,
               lp-solve (>= 5.5.0.13-5+b1),
               make (>= 3.81-8.2),
               openjdk-6-jdk (>= 6b23~pre8-2) [amd64 armel armhf i386 mips mipsel powerpc powerpcspe ppc64 s390 s390x sparc],
               openjdk-7-jdk [ia64],
               pkg-config,
               python (>= 2.6.6-3+squeeze4),
               python-dev (>= 2.7),
               python3,
               unixodbc-dev (>= 2.2.11),
               unzip,
               x11proto-render-dev,
               xsltproc,
               xulrunner-dev,
               zip,
               zlib1g-dev
Build-Depends-Indep: bsh (>= 2.0b4),
                     doxygen,
                     fdupes,
                     fontforge,
                     imagemagick,
                     libbase-java [!hppa !kfreebsd-amd64 !kfreebsd-i386],
                     libcommons-codec-java,
                     libcommons-httpclient-java,
                     libcommons-lang-java,
                     libcommons-logging-java (>= 1.1.1-9),
                     libflute-java (>= 1.1.6) [!hppa !kfreebsd-amd64 !kfreebsd-i386],
                     libfonts-java (>= 1.1.6) [!hppa !kfreebsd-amd64 !kfreebsd-i386],
                     libformula-java (>= 1.1.7) [!hppa !kfreebsd-amd64 !kfreebsd-i386],
                     liblayout-java (>= 0.2.10) [!hppa !kfreebsd-amd64 !kfreebsd-i386],
                     libloader-java (>= 1.1.6) [!hppa !kfreebsd-amd64 !kfreebsd-i386],
                     libpentaho-reporting-flow-engine-java (>= 0.9.4) [!hppa !kfreebsd-amd64 !kfreebsd-i386],
                     librepository-java (>= 1.1.6) [!hppa !kfreebsd-amd64 !kfreebsd-i386],
                     libsac-java [!hppa !kfreebsd-amd64 !kfreebsd-i386],
                     libserializer-java (>= 1.1.6) [!hppa !kfreebsd-amd64 !kfreebsd-i386],
                     libservlet2.5-java,
                     libxml-java (>= 1.1.6) [!hppa !kfreebsd-amd64 !kfreebsd-i386],
                     xml-core
Build-Conflicts: ant (= 1.8.0-1) [hppa kfreebsd-i386 kfreebsd-amd64],
                 ant (= 1.8.0-2) [hppa kfreebsd-i386 kfreebsd-amd64],
                 ant (= 1.8.0-3) [hppa kfreebsd-i386 kfreebsd-amd64],
                 flex (= 2.5.34-1) [amd64],
                 g++ (>= 4:4.7~) [!i386 !amd64 !kfreebsd-i386 !kfreebsd-amd64],
                 g++-4.6 (= 4.6.1-10),
                 g++-4.6 (= 4.6.1-11),
                 g++-4.7 (<< 4.7.1-3),
                 gcc (>= 4:4.7~) [!i386 !amd64 !kfreebsd-i386 !kfreebsd-amd64],
                 gcj-4.2 (= 4.2.2-6),
                 gjdoc (= 0.7.8-2),
                 graphicsmagick-imagemagick-compat (<< 1.3.9~),
                 libboost1.39-dev (<< 1.39.0-2),
                 libc0.1-dev (= 2.13-26) [kfreebsd-i386 kfreebsd-amd64],
                 libc6-dev (= 2.6.1-3) [i386 amd64],
                 libc6-dev (= 2.6.1-4) [i386 amd64],
                 libcairo2 (= 1.4.8-1),
                 libhsqldb-java (>= 1.8.1~),
                 libxul-dev (= 1.8.0.13~pre070720-0etch1),
                 nvidia-glx-dev,
                 nvidia-glx-legacy-dev,
                 qt3-dev-tools
Standards-Version: 3.9.4
XS-Python-Version: current
XS-Python3-Version: 3.3
XS-Testsuite: autopkgtest
Vcs-Git: https://alioth.debian.org/anonscm/git/pkg-openoffice/libreoffice.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-openoffice/libreoffice.git
Bugs: mailto:debian-backports@lists.debian.org
Homepage: http://www.libreoffice.org

Package: libreoffice
Architecture: amd64 armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc powerpcspe ppc64 s390 s390x sparc
Section: metapackages
Depends: fonts-sil-gentium-basic,
         libreoffice-base,
         libreoffice-calc,
         libreoffice-core (= ${binary:Version}),
         libreoffice-draw,
         libreoffice-filter-mobiledev,
         libreoffice-impress,
         libreoffice-math,
         libreoffice-report-builder-bin [!hppa !kfreebsd-amd64 !kfreebsd-i386],
         libreoffice-writer,
         ttf-dejavu,
         ${java-common-depends},
         ${misc:Depends},
         ${pyuno-depends}
Recommends: fonts-liberation | ttf-mscorefonts-installer, libpaper-utils
Suggests: cups-bsd,
          hunspell-dictionary,
          hyphen-hyphenation-patterns,
          iceweasel | firefox | icedove | thunderbird | iceape-browser | mozilla-browser,
          imagemagick | graphicsmagick-imagemagick-compat,
          libgl1,
          libreoffice-gnome | libreoffice-kde,
          libreoffice-grammarcheck,
          libreoffice-help-${help-l10n-virtual-version},
          libreoffice-l10n-${help-l10n-virtual-version},
          libsane,
          libxrender1,
          myspell-dictionary,
          mythes-thesaurus,
          openclipart-libreoffice,
          pstoedit,
          unixodbc,
          ${gstreamer-plugins-suggests},
          ${java-runtime-depends},
          ${ooo-officebean-dep}
Description: office productivity suite (metapackage)
 LibreOffice is a full-featured office productivity suite that provides
 a near drop-in replacement for Microsoft(R) Office.
 .
 This metapackage installs all components of libreoffice:
  * libreoffice-writer: Word processor
  * libreoffice-calc: Spreadsheet
  * libreoffice-impress: Presentation
  * libreoffice-draw: Drawing
  * libreoffice-base: Database
  * libreoffice-math: Equation editor
  * libreoffice-filter-mobiledev: Mobile Devices filters
 .
 You can extend the functionality of LibreOffice by installing these
 packages:
  * hunspell-*/myspell-*: Hunspell/Myspell dictionaries
    for use with LibreOffice
  * libreoffice-l10n-*: UI interface translation
  * libreoffice-help-*: User help
  * mythes-*: Thesauri for the use with LibreOffice
  * hyphen-*: Hyphenation patterns for LibreOffice
  * libreoffice-gtk: Gtk UI Plugin, GNOME File Picker support,
    QuickStarter for GNOMEs notification are
  * libreoffice-gnome: GIO, GConf backend
  * libreoffice-kde: KDE UI Plugin and KDE File Picker support
  * unixodbc: ODBC database support
  * cups-bsd: Allows LibreOffice to detect your CUPS printer queues
    automatically
  * libsane: Use your sane-supported scanner with LibreOffice
  * libxrender1: Speed up display by using Xrender library
  * libgl1: OpenGL support
  * openclipart-libreoffice: Open Clip Art Gallery with LibreOffice index
    files
  * iceweasel | firefox | icedove | thunderbird | iceape-browser | mozilla-browser:
    Mozilla profile with Certificates needed for XML Security...
  * openjdk-6-jre | gcj-jre | java5-runtime:
    Java Runtime Environment for use with LibreOffice
  * pstoedit / imagemagick: helper tools for EPS thumbnails
  * gstreamer0.10-plugins-*: GStreamer plugins for use with LibreOffices
    media backend
  * libpaper-utils: papersize detection support via paperconf
  * bluez: Bluetooth support for Impress (slideshow remote control

Package: libreoffice-l10n-za
Section: metapackages
Architecture: all
Depends: libreoffice-l10n-af,
         libreoffice-l10n-en-za,
         libreoffice-l10n-nr,
         libreoffice-l10n-nso,
         libreoffice-l10n-ss,
         libreoffice-l10n-st,
         libreoffice-l10n-tn,
         libreoffice-l10n-ts,
         libreoffice-l10n-ve,
         libreoffice-l10n-xh,
         libreoffice-l10n-zu,
         ${misc:Depends}
Description: office productivity suite -- South African language packages
 LibreOffice is a full-featured office productivity suite that provides
 a near drop-in replacement for Microsoft(R) Office.
 .
 This package is a metapackage installing l10n packages for all 11 South
 African languages.

Package: libreoffice-l10n-in
Section: metapackages
Architecture: all
Depends: libreoffice-l10n-as,
         libreoffice-l10n-bn,
         libreoffice-l10n-gu,
         libreoffice-l10n-hi,
         libreoffice-l10n-ml,
         libreoffice-l10n-mr,
         libreoffice-l10n-or,
         libreoffice-l10n-pa-in,
         libreoffice-l10n-ta,
         libreoffice-l10n-te,
         ${misc:Depends}
Recommends: fonts-indic
Description: office productivity suite -- Indic language packages
 LibreOffice is a full-featured office productivity suite that provides
 a near drop-in replacement for Microsoft(R) Office.
 .
 This package is a metapackage installing l10n packages for all available
 indic languages.

Package: libreoffice-core
Architecture: amd64 armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc powerpcspe ppc64 s390 s390x sparc
Depends: fontconfig,
         fonts-opensymbol,

=== debian/rules ===
#!/usr/bin/make -f
################################################################################
# LibreOffice source package rules file
#
# Please see debian/README for detailed documentation about the build system, and
# how to build LibreOffice.
################################################################################
# Authors:
# Chris Halls <halls@debian.org>
# Rene Engelhard <rene@debian.org>
# Copyright 2002-2013 Software in the Public Interest, Inc.
# Portions Copyright 2010 Canonical Ltd. Author: Matthias Klose
# Portions Copyright 2011-2013 Canonical Ltd. Author: Bjoern Michaelsen
# Licensed under the GNU General Public License, version 2.  See the file
# /usr/share/common-licenses/GPL or <http://www.gnu.org/copyleft/gpl.txt>.
################################################################################

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

include /usr/share/dpkg/pkg-info.mk
CURDIR ?= $(realpath $(dir $(firstword $(MAKEFILE_LIST)))/..)
BASE_VERSION:=$(shell echo $(DEB_VERSION) | cut -d: -f1):$(DEB_VERSION_UPSTREAM)
BINARY_VERSION=$(DEB_VERSION)
#HELP_L10N_VIRTUAL_VERSION:=$(shell echo $(DEB_VERSION_UPSTREAM) | cut -d: -f2 | tr [~] [\\-])
HELP_L10N_VIRTUAL_VERSION:=4.0
OOVER:=4.0
NEXT_OOVER:=$(shell echo "$(OOVER) + 0.1" | bc)

ARCH_INDEP_PACKAGES := $(shell dh_listpackages -i)
ARCH_DEP_PACKAGES := $(shell dh_listpackages -s)
PACKAGES := $(ARCH_INDEP_PACKAGES) $(ARCH_DEP_PACKAGES)

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/vendor.mk
SHELL:=/bin/bash
export gb_SHELL:=$(SHELL)

SYSTEM_GCC_VERSION = $(shell gcc --version | sed -n '/^gcc/s/.*\(.\..\)\..$$/\1/p')

# Debian buildds run as user `buildd', other are using /CurrentlyBuilding
ON_BUILDD := $(shell if [ "`whoami`" = buildd -o -f /CurrentlyBuilding ] || echo $(CURDIR) | grep -q \/build\/buildd; then echo y; else echo n; fi)

PKGDIR:=debian/libreoffice
OODIRNAME=libreoffice
OODIR:=usr/lib/$(OODIRNAME)
OOUREDIR:=usr/lib/ure
OOSDKDIR:=$(OODIR)/sdk

# Figure out who's building this package.
OOO_VENDOR:=The Document Foundation/Debian
ifeq "$(DEB_VENDOR)" "Ubuntu"
OOO_VENDOR=The Document Foundation, Debian and Ubuntu
endif
export OOO_VENDOR

# debhelper
export DH_OPTIONS
export DH_ALWAYS_EXCLUDE=CVS:.svn:.bzr:.git
#export DH_VERBOSE=1
# quilt
export QUILT_PATCHES=debian/patches
export QUILT_OPTIONS="-p1 -F0"

SOURCE_TREE=.
STAMP_DIR=debian/stampdir
TARFILE_LOCATION=$(CURDIR)/src
export TARFILE_LOCATION
USE_SOURCE_TARBALLS=y
USE_GIT_TARBALLS=n
ifeq "$(USE_GIT_TARBALLS)" "y"
GIT_BASEURL:=git://anongit.freedesktop.org/libreoffice
lo_sources_ver=4.0.3.3
# NOT in proper libreoffice-3-6 branch
# use ./g checkout -b tag-libreoffice-3.6.2.1 libreoffice-3.6.2.1
GIT_TAG=libreoffice-$(lo_sources_ver)
GIT_BRANCH=libreoffice-4-0-3
endif
ifeq "$(USE_SOURCE_TARBALLS)" "y"
lo_sources_ver=$(shell cat $(CURDIR)/sources.ver | cut -d= -f2)
endif

#########
# Default package configuration
#
OOO_ARCHS = amd64 armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc powerpcspe ppc64 s390 s390x sparc
PATCHSET=$(DEB_VENDOR)
BUILD_DEPS=\
    autoconf,\
    automake,\
    bc,\
    bison,\
    bzip2,\
    dpkg-dev (>= 1.16.1),\
    fastjar,\
    flex | flex-old,\
    gperf,\
    libarchive-zip-perl,\
    libc0.1 (>= 2.10.2-7) [kfreebsd-i386 kfreebsd-amd64],\
    libcups2-dev,\
    libfontconfig1-dev,\
    libfreetype6-dev,\
    libice-dev,\
    libsm-dev,\
    libx11-dev,\
    libxaw7-dev,\
    libxext-dev,\
    libxinerama-dev,\
    libxkbfile-dev,\
    libxml-parser-perl,\
    libxt-dev,\
    libxtst-dev,\
    pkg-config,\
    unzip,\
    x11proto-render-dev,\
    xsltproc,\
    zip,\
    zlib1g-dev\

# These are components which can be built from internal copies, or used from the
# distribution. See configure --help for valid values (--with-system-<value>).
SYSTEM_STUFF = dicts

ENABLE_PYTHON=y
ENABLE_PYTHON2=y
ifeq "$(ENABLE_PYTHON)" "y"
  ENABLE_SCRIPT_PROVIDER_PYTHON=y
  PACKAGE_LIBRELOGO=y
endif
# THIS IS ONLY FOR TESTING. When building against a specified pythonX.Y
# this will work inside OOo but *not* from outside OOo unless the user
# uses pythonX.Y directly (and the dh_pycentral-created dependencies allow
# also the non-working default python then) - see e.g. #587402. Also
# note we are NOT working with python < 2.6 anymore!
# Also note that you need to adapt all package names...
PYTHON_VERSION=3.3
ifeq "$(PYTHON_VERSION)" "current"
  PYTHON=python3
export PYTHON=python3
else
  PYTHON=python$(PYTHON_VERSION)
export PYTHON=python$(PYTHON_VERSION)
endif
ifeq "$(ENABLE_PYTHON2)" "y"
	PYTHON2_VERSION=current
  ifeq "$(PYTHON2_VERSION)" "current"
	PYTHON2=python
  else
	PYTHON2=python$(PYTHON2_VERSION)
  endif
endif
PACKAGE_TTF_OPENSYMBOL=y
BUILD_ONLY_EN_US=n
ENABLE_JAVA=y
ifeq "$(ENABLE_JAVA)" "y"
  JDK=openjdk
  JAVA_MAINVER=6
  ifneq (,$(filter hppa kfreebsd%, $(DEB_HOST_ARCH)))
    JDK=gcj-jdk
  endif
endif
JAVAHELPER_MIN_VERSION= (>= 0.37~)
SYSTEM_STUFF += hunspell
HUNSPELL_MIN_VER= (>= 1.1.5-2)
SYSTEM_STUFF += altlinuxhyph
USE_LIBHYPHEN=y
LIBALTLINUXHYPH_MINVER= (>= 0.1.1-11)
LIBHYPHEN_MINVER= (>= 2.4)
SYSTEM_STUFF += boost
#ifeq "$(WHEEZY_BACKPORT)" "y"
  BOOST_VERSION=default
#else
#  BOOST_VERSION=1.53
#endif
ifeq "$(BOOST_VERSION)" "default"
  ifeq "$(SYSTEM_GCC_VERSION)" "4.8"
    # see 701310/695826
    BOOST_MINVER= (>= 1.53)
  else
    BOOST_MINVER= (>= 1.38)
  endif
endif
ifeq "$(BOOST_VERSION)" "1.39"
  BOOST_MINVER= (>= 1.39.0-2)
endif
SYSTEM_STUFF += mdds
SYSTEM_STUFF += vigra
USE_EXTERNAL_CXXLIBS=y
#SYSTEM_STUFF += sablot
SYSTEM_STUFF += mythes
SYSTEM_STUFF += icu
ICU_MINVER= (>= 4.6)
SYSTEM_STUFF += libwpd libwpg libwps
SYSTEM_STUFF += libvisio
SYSTEM_STUFF += libcdr
SYSTEM_STUFF += libmspub
#SYSTEM_STUFF += xmlsec
BUILD_CAIROCANVAS=y
SYSTEM_STUFF += cairo
CAIRO_FONTS_PATCH=y
BUILD_KDE=y
# not ported to KDE 4
ENABLE_KDEAB=n
ifeq "$(SYSTEM_GCC_VERSION)" "4.7"
# < 4.8 fails with gcc 4.7, see #667911
QT_MINVER= (>= 4:4.8)
else
QT_MINVER= (>= 4:4.5)
endif
KDELIBS_MINVER= (>= 4:4.3.4)
BUILD_DBG_PACKAGE=y
ifneq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  BUILD_TEST_PACKAGE=y
endif
ifeq "$(BUILD_TEST_PACKAGE)" "y"
  BUILD_DBG_PACKAGE=y
endif
ifeq "$(BUILD_DBG_PACKAGE)" "y"
  ENABLE_SYMBOLS=y
  SMALL_SYMBOLS=y
endif
ifeq "$(ENABLE_JAVA)" "y"
  # NOTE: If you change this while gcj/ant multiarch combo is still broken
  # you need to disable bsh scripting engine completely (see disable-rhino.diff)
  # See http://lists.debian.org/debian-java/2011/06/msg00108.html and replies
  SYSTEM_STUFF += beanshell
  SYSTEM_STUFF += hsqldb
  HSQLDB_MINVER= (>> 1.8.0.10)
  HSQLDB_TOONEWVER=1.8.1
  ifeq "$(WHEEZY_BACKPORT)" "y"
    HSQLDB_JAR=/usr/share/java/hsqldb.jar
  else
    HSQLDB_JAR=/usr/share/java/hsqldb1.8.0.jar
  endif
endif
SYSTEM_STUFF += lpsolve
USE_SHARED_LPSOLVE=y
LPSOLVE_MIN_VERSION= (>= 5.5.0.13-5+b1)
USE_DBUS=y
ifeq "$(USE_DBUS)" "y"
  ifneq (,$(findstring kfreebsd,$(DEB_HOST_ARCH)))
    ENABLE_BLUETOOTH=n
  else
    ENABLE_BLUETOOTH=y
    SYSTEM_STUFF += bluez
  endif
endif
USE_GSTREAMER=y
#ifneq "$(WHEEZY_BACKPORT)" "y"
#  GSTREAMER_VERSION=1.0
#else
   GSTREAMER_VERSION=0.10
#endif
SYSTEM_STUFF += neon
NEON_SECTYPE=gnutls
NEONSONR=27
SYSTEM_STUFF += redland
PACKAGE_SDK=y
PACKAGE_SDK_DOCS=y
ifeq "$(ENABLE_JAVA)" "y"
  ifeq "$(JDK)" "default"
    ifeq "$(shell LANG=C /usr/lib/jvm/default-java/bin/java -version 2>&1 | tail -n 1 | awk '{ print $$1 }')" "OpenJDK"
      RUN_MAKE_CHECK=y
      ENABLE_JUNIT4=y
    endif
  else
    ifeq "$(JDK)" "openjdk"
      RUN_MAKE_CHECK=y
      ENABLE_JUNIT4=y
    else
      RUN_MAKE_CHECK=n
      ENABLE_JUNIT4=n
    endif
  endif
else
  RUN_MAKE_CHECK=n
  ENABLE_JUNIT4=n
endif
ifeq "$(ENABLE_JUNIT4)" "y"
  JUNIT_MIN_VER= (>= 4.8.2-2)
endif
USE_LIBCURL4=y
CURL_SECTYPE=gnutls
USE_SYSTEM_DMAKE=y
USE_LIBSUITESPARSE=y
SUITESPARSE_MIN_VERSION= (>= 1:3.4.0)
PARALLEL_BUILD=y
ENABLE_LDAP=y
USE_OPENLDAP=y
ENABLE_OPENGL=y
SYSTEM_STUFF += openssl
NEW_DPKG_SHLIBDEPS=y
ifeq "$(ENABLE_JAVA)" "y"
